"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.run = exports.program = exports.goForward = exports.goBack = exports.replace = exports.push = exports.history = void 0;
const R = __importStar(require("fp-ts-rxjs/lib/Observable"));
const function_1 = require("fp-ts/lib/function");
const T = __importStar(require("fp-ts/lib/Task"));
const rxjs_1 = require("rxjs");
const Cmd_1 = require("./Cmd");
const html = __importStar(require("./Html"));
const sub = __importStar(require("./Sub"));
function history(history) {
    return {
        location: history.location,
        push: url => () => history.push(url),
        replace: url => () => history.replace(url),
        goBack: () => history.goBack(),
        goForward: () => history.goForward(),
        listen: f => () => history.listen(f)
    };
}
exports.history = history;
const push = (url) => (0, Cmd_1.perform_)(env => T.fromIO(env.history.push(url)));
exports.push = push;
const replace = (url) => (0, Cmd_1.perform_)(env => T.fromIO(env.history.replace(url)));
exports.replace = replace;
const goBack = () => (0, Cmd_1.perform_)(env => T.fromIO(env.history.goBack));
exports.goBack = goBack;
const goForward = () => (0, Cmd_1.perform_)(env => T.fromIO(env.history.goForward));
exports.goForward = goForward;
function program(locationUpdateToMessage, init, update, view, subscriptions = sub.none) {
    const monoidSubR = sub.getMonoid();
    return env => {
        const update$ = new rxjs_1.Subject();
        const onChangeLocation = sub.fromObservable((0, function_1.pipe)(update$, R.map(locationUpdateToMessage)));
        const subs = monoidSubR.concat(subscriptions, onChangeLocation);
        return Object.assign(Object.assign({}, html.program(init(env.history.location), update, view, subs)(env)), { listen: env.history.listen((location, action) => update$.next({ location, action })) });
    };
}
exports.program = program;
function run(program, renderer, env) {
    const p = program(env);
    p.listen();
    return html.run(() => p, renderer, env);
}
exports.run = run;
//# sourceMappingURL=Navigation.js.map